<template>
  <ms-modal
    :v-model="vModel"
    :id="GLOBALS.__APP_NAME__ + '-create-category-modal'"
    :title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.createCategory.title`))"
    :ok="ok"
    :ok-title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.createCategory.okTitle`))"
    :ok-state="isValid"
    :cancel="cancel"
    :cancel-title="$h.capitalize($t(`global.cancel`))"
    :hide-buttons="!showModalContent"
    @ok="$emit('ok')"
    @cancel="$emit('cancel')"
  >
    <transition
      mode="out-in"
      enter-active-class="animated fadeIn fast"
      leave-active-class="animated fadeOut fast"
    >
      <div :id="GLOBALS.__APP_NAME__ + '-create-category-modal'" v-if="showModalContent" key="modal-content">
        <b-form class="mb-3">
          <!-- Label input -->
          <b-form-group
            id="input-group-label"
            :label="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.global.label`) + ':')"
            label-for="create-category-input-label"
          >
            <b-form-input
              v-model="newCategory.label"
              id="create-category-input-label"
              type="text"
              :state="labelState"
              required
              :placeholder="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.global.label`))"
              class="ms_input mb-2"
            />
          </b-form-group>
          <!-- Color label -->
          <label for="create-category-input-color">{{ $t(`global.color`) | capitalize }}:</label>
          <!-- Color picker -->
          <ms-color-picker
            :color="newCategory.color"
            class="create-category-color-picker"
            @update="pickColor"
          ></ms-color-picker>
          <!-- Color input -->
          <div class="color-picker-input">
            <b-form-input
              v-model="newCategory.color"
              id="create-category-input-color"
              type="text"
              :state="colorState"
              :formatter="colorFormatter"
              required
              :placeholder="GLOBALS.__APP_COLOR__"
              class="ms_input mb-2"
            />
            <div class="color-picker-input-indicator" :style="'background-color: ' + newCategory.color + ';'"></div>
          </div>
        </b-form>
      </div>
      <div v-else key="modal-loading">
        <icon-basic-load width="28" height="28"/>
        <span>{{ $t("global.loading") }}</span>
      </div>
    </transition>
  </ms-modal>
</template>

<script>
import { BaseComponent } from '@/utils/'

export default {
  extends: BaseComponent,
  data () {
    return {
      newCategory: {
        label: '',
        color: __APP_COLOR__
      }
    }
  },
  computed: {
    colorState: function () {
      const regex = /^#[ABCDEF0-9]{6}$/
      if (regex.test(this.newCategory.color)) {
        return true
      } else {
        return false
      }
    },
    labelState: function () {
      return this.newCategory.label.length > 0
    },
    isValid: function () {
      return this.labelState && this.colorState
    },
    showModalContent: function () {
      return !this.categoriesCreating && !this.categoriesLoading
    }
  },
  props: {
    // V-Model: to show the modal
    vModel: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    ok: async function () {
      await this.createCategories({
        label: this.newCategory.label,
        color: this.newCategory.color
      })
      await this.loadCategories()
      this.newCategory = {
        label: '',
        color: __APP_COLOR__
      }
      return true
    },
    cancel: function () {
      return true
    },
    colorFormatter: function (value) {
      return value.toUpperCase()
    },
    pickColor: function (val) {
      this.newCategory.color = val.hex
    }
  },
  state: {
    MyFeedsModule: [
      'categoriesLoading',
      'categoriesCreating'
    ]
  },
  actions: {
    MyFeedsModule: [
      'loadCategories',
      'createCategories'
    ]
  }
}
</script>
